#ifndef MOTOR_H
#define MOTOR_H

#include "main.h"

// モータ名
typedef enum {
	MOTOR_1 = 0,
	MOTOR_2,
	MOTOR_3,
	MOTOR_4
} MOTOR_n;

// モータの初期設定
void motor_init(TIM_HandleTypeDef *p_htim);

// モータの有効化、無効化
void motor_enable();
void motor_disable();

// モータmotor_iの出力をpwm_fval=0.0〜1.0で設定。反対側ブリッジをc_val=[0,1]で設定。
int motor_fore_pwm(MOTOR_n motor_i, float pwm_fval, int c_val);
int motor_back_pwm(MOTOR_n motor_i, float pwm_fval, int c_val);

// モータmotor_iの前進・反転出力をpwm_fore_val,pwm_back=0.0〜1.0で設定。
// ただし、pwm_fore_val,pwm_back_valの少なくとも一方は0.0または1.0でなければならない。
int motor_pwm(MOTOR_n motor_i, float pwm_fore_fval, float pwm_back_fval);

// モータの動作確認（4つすべて）
void motor4_test(int speedCount[4], uint8_t ser);

// テスト動作その0
void motor_test0();
// テスト動作その1
void motor_test1();
// テスト動作その2
void motor_test2();

// モータ動作チェック
void motor_check();

#endif
